name             'ohmage'
maintainer       'Steve Nolen'
maintainer_email 'technolengy@gmail.com'
license          'Apache 2.0'
description      'Installs ohmage server and related clients'
long_description IO.read(File.join(File.dirname(__FILE__), 'README.md'))
version          '0.1.0'

depends 'java'
depends 'tomcat'
depends 'build-essential'
depends 'mysql'
depends 'git'
depends 'ant'
depends 'nginx'

supports 'ubuntu'

recipe 'ohmage::default', 'installs the ohmage server'
recipe 'ohmage::server_download', 'downloads pre-compiled war file for ohmage server'
recipe 'ohmage::server_source', 'gets source from git and compiles war file for ohmage server'
recipe 'ohmage::mysql', 'installs and prepares the ohmage db backend. probably refactor this out eventually'
recipe 'ohmage::nginx', 'installs and configures nginx as a reverse proxy and static client web server'
recipe 'ohmage::frontends', 'downloads pre-compiled ohmage clients to use'
recipe 'ohmage::gwt-front-end_source', 'compiles gwt frontend to use'
recipe 'ohmage::db-prep', 'prepares the ohmage db for use. also updates some of the preferences.'