#
# Cookbook Name:: ohmage
# Recipe:: default
#
# Author: Steve Nolen <technolengy@gmail.com>
#
# Copyright (c) 2014, UC Regents.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

node.override['java']['jdk_version'] = 7
#some bug in the tomcat chef repo
node.override['tomcat']['base_version'] = 7
node.override['tomcat']['user'] = "tomcat#{node["tomcat"]["base_version"]}"
node.override['tomcat']['group'] = "tomcat#{node["tomcat"]["base_version"]}"
node.override['tomcat']['home'] = "/usr/share/tomcat#{node["tomcat"]["base_version"]}"
node.override['tomcat']['base'] = "/var/lib/tomcat#{node["tomcat"]["base_version"]}"
node.override['tomcat']['config_dir'] = "/etc/tomcat#{node["tomcat"]["base_version"]}"
node.override['tomcat']['log_dir'] = "/var/log/tomcat#{node["tomcat"]["base_version"]}"
node.override['tomcat']['tmp_dir'] = "/tmp/tomcat#{node["tomcat"]["base_version"]}-tmp"
node.override['tomcat']['work_dir'] = "/var/cache/tomcat#{node["tomcat"]["base_version"]}"
node.override['tomcat']['webapp_dir'] = "/var/lib/tomcat#{node["tomcat"]["base_version"]}/webapps"


include_recipe "java"
include_recipe "tomcat"

include_recipe "ohmage::server_#{node['ohmage']['install_method']}"

#add ohmage.conf
template '/etc/ohmage.conf' do
  source 'ohmage.conf.erb'
  action :create
end

directory node['ohmage']['log_dir'] do
  mode 0755
  owner    node["tomcat"]["user"]
  group    node["tomcat"]["group"]
  action :create
end

directory node['ohmage']['data_dir'] do
  mode 0755
  owner    node["tomcat"]["user"]
  group    node["tomcat"]["group"]
  action :create
end

for dir in ["audits", "audio", "images", "documents", "videos"]
 directory dir do
  mode 0755
  owner    node["tomcat"]["user"]
  group    node["tomcat"]["group"]
  action :create
 end
end

include_recipe "ohmage:db-prep"
