#
# Cookbook Name:: ohmage
# Recipe:: gwt-front-end_source
#
# Author: Steve Nolen <technolengy@gmail.com>
#
# Copyright (c) 2014, UC Regents.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#gwt needs java6 to compile. probably use a 'download' method instead 
node.override['java']['jdk_version'] = 6
include_recipe 'java'

include_recipe "git"
include_recipe "ant"
include "ohmage::nginx"

### compile and deploy the gwt web frontend.
directory "/usr/src/ohmage-gwt-front-end" do
  mode 0755
  action :create
end

directory "#{node['ohmage']['navbar']['webclients_dir']}/web" do
  mode 0755
  action :create
  owner node['nginx']['user']
  group node['nginx']['group']
end

git "/usr/src/ohmage-gwt-front-end" do
  repository "https://github.com/ohmage/gwt-front-end.git"
  reference "master"
  action :sync
  notifies :run, "execute[compile-ohmage-gwt-front-end]", :immediately
end

execute "compile-ohmage-gwt-front-end" do
  cwd "/usr/src/ohmage-gwt-front-end"
  command 'ant clean build buildwar'
  action :nothing
  notifies :run, "execute[extract-ohmage-gwt-front-end]", :immediately
end

execute "extract-ohmage-gwt-front-end" do
  cwd "#{node['ohmage']['navbar']['webclients_dir']}/web"
  command 'jar xvf /usr/src/ohmage-gwt-front-end/MobilizeWeb.war'
  action :nothing
end
