#
# Cookbook Name:: ohmage
# Recipe:: mysql
#
# Author: Steve Nolen <technolengy@gmail.com>
#
# Copyright (c) 2014, UC Regents.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_recipe "mysql::server"
include_recipe "mysql::client"

node.default['ohmage']['db']['host'] = 'localhost'
node.default['ohmage']['db']['port'] = node['mysql']['port']

#right now, I really hate the database cookbook since the stupid mysql_chef_gem wont install without a headache and a half
execute "add-mysql-ohmage-db" do
  command "/usr/bin/mysql --host=#{node['ohmage']['db']['host']} --port=#{node['ohmage']['db']['port']} -u root -p#{node['mysql']['server_root_password']} -D mysql -r -B -N -e \"CREATE DATABASE #{node['ohmage']['db']['name']}\""
  action :run
  only_if { `/usr/bin/mysql --host=#{node['ohmage']['db']['host']} --port=#{node['ohmage']['db']['port']} -u root -p#{node['mysql']['server_root_password']} -D mysql -r -B -N -e \"SELECT COUNT(*) FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '#{node['ohmage']['db']['name']}'\"`.to_i == 0 }
end

execute "add-mysql-user-ohmage" do
  command "/usr/bin/mysql --host=#{node['ohmage']['db']['host']} --port=#{node['ohmage']['db']['port']} -u root -p#{node['mysql']['server_root_password']} -D mysql -r -B -N -e \"CREATE USER '#{node['ohmage']['db']['name']}'@'#{node['ohmage']['db']['host']}' IDENTIFIED BY '&!sickly'\""
  action :run
  notifies :run, "execute[grant-mysql-user-ohmage]", :immediately
  only_if { `/usr/bin/mysql --host=#{node['ohmage']['db']['host']} --port=#{node['ohmage']['db']['port']} -u root -p#{node['mysql']['server_root_password']} -D mysql -r -B -N -e \"SELECT COUNT(*) FROM user where User='#{node['ohmage']['db']['user']}' and Host = '#{node['ohmage']['db']['host']}'\"`.to_i == 0 }
end

execute "grant-mysql-user-ohmage" do
  command "/usr/bin/mysql --host=#{node['ohmage']['db']['host']} --port=#{node['ohmage']['db']['port']} -u root -p#{node['mysql']['server_root_password']} -D mysql -r -B -N -e \"GRANT ALL on #{node['ohmage']['db']['name']}.* to '#{node['ohmage']['db']['user']}'@'#{node['ohmage']['db']['host']}'\""
  action :nothing
  notifies :run, "execute[mysql-flush-privileges]", :immediately
end

execute "mysql-flush-privileges" do
  command "/usr/bin/mysql --host=#{node['ohmage']['db']['host']} --port=#{node['ohmage']['db']['port']} -u root -p\"#{node['mysql']['server_root_password']}\" -D mysql -r -B -N -e \"FLUSH PRIVILEGES\""
  action :nothing
end