#
# Cookbook Name:: ohmage
# Recipe:: server_download
#
# Author: Steve Nolen <technolengy@gmail.com>
#
# Copyright (c) 2014, UC Regents.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

#grab pre-compiled ohmage server war
if node['ohmage']['user_setup']
 war_url = "https://web.ohmage.org/ohmage/packages/#{node['ohmage']['version']}/server/app-user_setup.war"
else
 war_url = "https://web.ohmage.org/ohmage/packages/#{node['ohmage']['version']}/server/app.war"
end

remote_file war_url do
  source   war_url
  path     "#{node['tomcat']['webapp_dir']}/app.war"
  owner    node["tomcat"]["user"]
  group    node["tomcat"]["group"]
  backup   false
  notifies :restart, "service[tomcat7]"
end
