#
# Cookbook Name:: ohmage
# Recipe:: server_source
#
# Author: Steve Nolen <technolengy@gmail.com>
#
# Copyright (c) 2014, UC Regents.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include_recipe "git"
include_recipe "ant"

directory "/usr/src/ohmage-#{node['ohmage']['version']}" do
  mode 0755
  action :create
end

git "/usr/src/ohmage-#{node['ohmage']['version']}" do
  repository "https://github.com/ohmage/server.git"
  reference "master"
  action :sync
  notifies :run, "execute[compile-ohmage-server]", :immediately
end

execute "compile-ohmage-server" do
  cwd "/usr/src/ohmage-#{node['ohmage']['version']}"
  command 'ant clean dist'
  action :nothing
end

file "#{node['tomcat']['webapp_dir']}/app.war" do
  owner    node["tomcat"]["user"]
  group    node["tomcat"]["group"]
  content  lazy { ::File.open("/usr/src/ohmage-#{node['ohmage']['version']}/dist/webapp-ohmage-#{node['ohmage']['version']}-no_ssl.war").read }
  action :create
  notifies :restart, "service[tomcat7]"
end